<?php










include_once(dirname(__FILE__).'/languages/languages.php');


include_once(dirname(__FILE__).'/PGTStorage/pgt-main.php');









class CASClient
{
 
 
 
 
 
 
 
 
 
 
 


 
 
 












 function HTMLFilterOutput($str)
 {
 $str = str_replace('__CAS_VERSION__',$this->getServerVersion(),$str);
 $str = str_replace('__PHPCAS_VERSION__',phpCAS::getVersion(),$str);
 $str = str_replace('__SERVER_BASE_URL__',$this->getServerBaseURL(),$str);
 echo $str;
 }
 
 







 var $_output_header = '';
 
 








 function printHTMLHeader($title)
 {
 $this->HTMLFilterOutput(str_replace('__TITLE__',
 $title,
 (empty($this->_output_header)
 ? '<html><head><title>__TITLE__</title></head><body><h1>__TITLE__</h1>'
 : $this->_output_header)
 )
 );
 }
 
 







 var $_output_footer = '';
 
 






 function printHTMLFooter()
 {
 $this->HTMLFilterOutput(empty($this->_output_footer)
 ?('<hr><address>phpCAS __PHPCAS_VERSION__ '.$this->getString(CAS_STR_USING_SERVER).' <a href="__SERVER_BASE_URL__">__SERVER_BASE_URL__</a> (CAS __CAS_VERSION__)</a></address></body></html>')
 :$this->_output_footer);
 }
 
 






 function setHTMLHeader($header)
 {
 $this->_output_header = $header;
 }
 
 






 function setHTMLFooter($footer)
 {
 $this->_output_footer = $footer;
 }
 
 
 
 
 
 


 
 









 var $_lang = '';
 
 






 function getLang()
 {
 if ( empty($this->_lang) )
 $this->setLang(PHPCAS_LANG_DEFAULT);
 return $this->_lang;
 }
 
 








 var $_strings;
 
 








 function getString($str)
 {
 
 $this->getLang();
 
 if ( !isset($this->_strings[$str]) ) {
 trigger_error('string `'.$str.'\' not defined for language `'.$this->getLang().'\'',E_USER_ERROR);
 }
 return $this->_strings[$str];
 }
 
 








 function setLang($lang)
 {
 
 include_once(dirname(__FILE__).'/languages/'.$lang.'.php');
 
 if ( !is_array($this->_strings) ) {
 trigger_error('language `'.$lang.'\' is not implemented',E_USER_ERROR);
 }
 $this->_lang = $lang;
 }
 
 
 
 
 
 


 
 
 























 var $_server = array(
 'version' => -1,
 'hostname' => 'none',
 'port' => -1,
 'uri' => 'none',
 'schema' => 'https',
 );
 
 




 function getServerVersion()
 { 
 return $this->_server['version']; 
 }
 
 




 function getServerHostname()
 { return $this->_server['hostname']; }
 
 




 function getServerPort()
 { return $this->_server['port']; }
 
 




 function getServerURI()
 { return $this->_server['uri']; }
 
 




 function getServerBaseURL()
 { 
 
 if ( empty($this->_server['base_url']) ) {
 $this->_server['base_url'] = $this->getServerSchema().'://'
 .$this->getServerHostname()
 .':'
 .$this->getServerPort()
 .$this->getServerURI();
 }
 return $this->_server['base_url']; 
 }

 function getServerSchema() {
 return $this->_server['schema'];
 }

 function setServerSchema($schema) {
 $this->_server['schema'] = $schema;
 }
 
 








 function getServerLoginURL($gateway=false,$renew=false) {
 phpCAS::traceBegin();
 
 if ( empty($this->_server['login_url']) ) {
 $this->_server['login_url'] = $this->getServerBaseURL();
 $this->_server['login_url'] .= 'login?service=';
 
 $this->_server['login_url'] .= urlencode($this->getURL());
 if($renew) {
 
 $this->_server['login_url'] .= '&renew=true';
 } elseif ($gateway) {
 
 $this->_server['login_url'] .= '&gateway=true';
 }
 }
 phpCAS::traceEnd($this->_server['login_url']);
 return $this->_server['login_url'];
 } 
 
 





 function setServerLoginURL($url)
 {
 return $this->_server['login_url'] = $url;
 }
 
 




 function getServerServiceValidateURL()
 { 
 
 if ( empty($this->_server['service_validate_url']) ) {
 switch ($this->getServerVersion()) {
 case CAS_VERSION_1_0:
 $this->_server['service_validate_url'] = $this->getServerBaseURL().'validate';
 break;
 case CAS_VERSION_2_0:
 $this->_server['service_validate_url'] = $this->getServerBaseURL().'serviceValidate';
 break;
 }
 }
 
 return $this->_server['service_validate_url'].'?service='.urlencode($this->getURL()); 
 }
 




 function getServerSamlValidateURL()
 {
 phpCAS::traceBegin();
 
 if ( empty($this->_server['saml_validate_url']) ) {
 switch ($this->getServerVersion()) {
 case SAML_VERSION_1_1:
 $this->_server['saml_validate_url'] = $this->getServerBaseURL().'samlValidate';
 break;
 }
 }
 phpCAS::traceEnd($this->_server['saml_validate_url'].'?TARGET='.urlencode($this->getURL()));
 return $this->_server['saml_validate_url'].'?TARGET='.urlencode($this->getURL());
 }
 




 function getServerProxyValidateURL()
 { 
 
 if ( empty($this->_server['proxy_validate_url']) ) {
 switch ($this->getServerVersion()) {
 case CAS_VERSION_1_0:
 $this->_server['proxy_validate_url'] = '';
 break;
 case CAS_VERSION_2_0:
 $this->_server['proxy_validate_url'] = $this->getServerBaseURL().'proxyValidate';
 break;
 }
 }
 
 return $this->_server['proxy_validate_url'].'?service='.urlencode($this->getURL()); 
 }
 
 




 function getServerProxyURL()
 { 
 
 if ( empty($this->_server['proxy_url']) ) {
 switch ($this->getServerVersion()) {
 case CAS_VERSION_1_0:
 $this->_server['proxy_url'] = '';
 break;
 case CAS_VERSION_2_0:
 $this->_server['proxy_url'] = $this->getServerBaseURL().'proxy';
 break;
 }
 }
 return $this->_server['proxy_url']; 
 }
 
 




 function getServerLogoutURL()
 { 
 
 if ( empty($this->_server['logout_url']) ) {
 $this->_server['logout_url'] = $this->getServerBaseURL().'logout';
 }
 return $this->_server['logout_url']; 
 }
 
 





 function setServerLogoutURL($url)
 {
 return $this->_server['logout_url'] = $url;
 }

 

 
 var $_curl_options = array();

 


 function setExtraCurlOption($key, $value)
 {
 $this->_curl_options[$key] = $value;
 }
 
 




 function isHttps() {
 
 
 if ( isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
 return true;
 } else {
 return false;
 }
 }
 
 
 
 
 













 function CASClient(
 $server_version,
 $proxy,
 $server_hostname,
 $server_port,
 $server_uri,
 $start_session = true) {
 
 phpCAS::traceBegin();
 
 
 if (version_compare(PHP_VERSION,'5','>=') && ini_get('zend.ze1_compatibility_mode')) {
 phpCAS::error('phpCAS cannot support zend.ze1_compatibility_mode. Sorry.');
 }

 if (!$this->isLogoutRequest() && !empty($_GET['ticket']) && $start_session) {
 
 if (!isset($_SESSION)) {
 session_start();
 }
 $old_session = $_SESSION;
 session_destroy();
 
 
 $session_id = preg_replace('/[^\w]/','',$_GET['ticket']);
 phpCAS::LOG("Session ID: " . $session_id);
 session_id($session_id);
 if (!isset($_SESSION)) {
 session_start();
 }
 
 $_SESSION = $old_session;
 }
 
 
 if (!$this->isLogoutRequest() && $start_session) {
 session_start();
 }
 
 
 $this->_proxy = $proxy;
 
 
 switch ($server_version) {
 case CAS_VERSION_1_0:
 if ( $this->isProxy() )
 phpCAS::error('CAS proxies are not supported in CAS '
 .$server_version);
 break;
 case CAS_VERSION_2_0:
 break;
 case SAML_VERSION_1_1:
 break;
 default:
 phpCAS::error('this version of CAS (`'
 .$server_version
 .'\') is not supported by phpCAS '
 .phpCAS::getVersion());
 }
 $this->_server['version'] = $server_version;
 
 
 if ( empty($server_hostname) 
 || !preg_match('/[\.\d\-abcdefghijklmnopqrstuvwxyz]*/',$server_hostname) ) {
 phpCAS::error('bad CAS server hostname (`'.$server_hostname.'\')');
 }
 $this->_server['hostname'] = $server_hostname;
 
 
 if ( $server_port == 0 
 || !is_int($server_port) ) {
 phpCAS::error('bad CAS server port (`'.$server_hostname.'\')');
 }
 $this->_server['port'] = $server_port;
 
 
 if ( !preg_match('/[\.\d\-_abcdefghijklmnopqrstuvwxyz\/]*/',$server_uri) ) {
 phpCAS::error('bad CAS server URI (`'.$server_uri.'\')');
 }
 
 $server_uri = preg_replace('/\/\//','/','/'.$server_uri.'/');
 $this->_server['uri'] = $server_uri;
 
 
 if ( $this->isProxy() ) {
 $this->setCallbackMode(!empty($_GET['pgtIou'])&&!empty($_GET['pgtId']));
 }
 
 if ( $this->isCallbackMode() ) {
 
 if ( !$this->isHttps() ) {
 phpCAS::error('CAS proxies must be secured to use phpCAS; PGT\'s will not be received from the CAS server');
 }
 } else {
 
 $ticket = (isset($_GET['ticket']) ? $_GET['ticket'] : null);
 switch ($this->getServerVersion()) {
 case CAS_VERSION_1_0: 
 if( preg_match('/^ST-/',$ticket) ) {
 phpCAS::trace('ST \''.$ticket.'\' found');
 
 $this->setST($ticket);
 
 unset($_GET['ticket']);
 } else if ( !empty($ticket) ) {
 
 phpCAS::error('ill-formed ticket found in the URL (ticket=`'.htmlentities($ticket).'\')');
 }
 break;
 case CAS_VERSION_2_0: 
 if( preg_match('/^[SP]T-/',$ticket) ) {
 phpCAS::trace('ST or PT \''.$ticket.'\' found');
 $this->setPT($ticket);
 unset($_GET['ticket']);
 } else if ( !empty($ticket) ) {
 
 phpCAS::error('ill-formed ticket found in the URL (ticket=`'.htmlentities($ticket).'\')');
 } 
 break;
 case SAML_VERSION_1_1: 
 if( preg_match('/^[SP]T-/',$ticket) ) {
 phpCAS::trace('SA \''.$ticket.'\' found');
 $this->setSA($ticket);
 unset($_GET['ticket']);
 } else if ( !empty($ticket) ) {
 
 phpCAS::error('ill-formed ticket found in the URL (ticket=`'.htmlentities($ticket).'\')');
 }
 break;
 }
 }
 phpCAS::traceEnd();
 }
 
 
 
 
 
 
 
 
 
 


 
 
 






 var $_user = '';
 
 






 function setUser($user)
 {
 $this->_user = $user;
 }
 
 






 function getUser()
 {
 if ( empty($this->_user) ) {
 phpCAS::error('this method should be used only after '.__CLASS__.'::forceAuthentication() or '.__CLASS__.'::isAuthenticated()');
 }
 return $this->_user;
 }


 
 





 





 
 var $_attributes = array();

 function setAttributes($attributes) 
 { $this->_attributes = $attributes; }
 
 function getAttributes() {
 if ( empty($this->_user) ) { 
 phpCAS::error('this method should be used only after '.__CLASS__.'::forceAuthentication() or '.__CLASS__.'::isAuthenticated()');
 }
 return $this->_attributes;
 }
 
 function hasAttributes()
 { return !empty($this->_attributes); }
 
 function hasAttribute($key)
 { return (is_array($this->_attributes) && array_key_exists($key, $this->_attributes)); }
 
 function getAttribute($key) {
 if($this->hasAttribute($key)) {
 return $this->_attributes[$key];
 }
 }
 
 





 function renewAuthentication(){
 phpCAS::traceBegin();
 
 if( isset( $_SESSION['phpCAS']['auth_checked'] ) )
 unset($_SESSION['phpCAS']['auth_checked']);
 if ( $this->isAuthenticated() ) {
 phpCAS::trace('user already authenticated; renew');
 $this->redirectToCas(false,true);
 } else {
 $this->redirectToCas();
 }
 phpCAS::traceEnd();
 }

 





 function forceAuthentication()
 {
 phpCAS::traceBegin();
 
 if ( $this->isAuthenticated() ) {
 
 phpCAS::trace('no need to authenticate');
 $res = TRUE;
 } else {
 
 if (isset($_SESSION['phpCAS']['auth_checked'])) {
 unset($_SESSION['phpCAS']['auth_checked']);
 }
 $this->redirectToCas(FALSE); 
 
 $res = FALSE;
 }
 phpCAS::traceEnd($res);
 return $res;
 }
 
 





 var $_cache_times_for_auth_recheck = 0;
 
 






 function setCacheTimesForAuthRecheck($n)
 {
 $this->_cache_times_for_auth_recheck = $n;
 }
 
 




 function checkAuthentication()
 {
 phpCAS::traceBegin();
 
 if ( $this->isAuthenticated() ) {
 phpCAS::trace('user is authenticated');
 $res = TRUE;
 } else if (isset($_SESSION['phpCAS']['auth_checked'])) {
 
 unset($_SESSION['phpCAS']['auth_checked']);
 $res = FALSE;
 } else {
 
 
 
 
 
 if (! isset($_SESSION['phpCAS']['unauth_count']) )
 $_SESSION['phpCAS']['unauth_count'] = -2; 
 
 if (($_SESSION['phpCAS']['unauth_count'] != -2 && $this->_cache_times_for_auth_recheck == -1) 
 || ($_SESSION['phpCAS']['unauth_count'] >= 0 && $_SESSION['phpCAS']['unauth_count'] < $this->_cache_times_for_auth_recheck))
 {
 $res = FALSE;
 
 if ($this->_cache_times_for_auth_recheck != -1)
 {
 $_SESSION['phpCAS']['unauth_count']++;
 phpCAS::trace('user is not authenticated (cached for '.$_SESSION['phpCAS']['unauth_count'].' times of '.$this->_cache_times_for_auth_recheck.')');
 }
 else
 {
 phpCAS::trace('user is not authenticated (cached for until login pressed)');
 }
 }
 else
 {
 $_SESSION['phpCAS']['unauth_count'] = 0;
 $_SESSION['phpCAS']['auth_checked'] = true;
 phpCAS::trace('user is not authenticated (cache reset)');
 $this->redirectToCas(TRUE); 
 
 $res = FALSE;
 }
 }
 phpCAS::traceEnd($res);
 return $res;
 }
 
 







 function isAuthenticated()
 {
 phpCAS::traceBegin();
 $res = FALSE;
 $validate_url = '';

 if ( $this->wasPreviouslyAuthenticated() ) {
 
 
 phpCAS::trace('user was already authenticated, no need to look for tickets');
 $res = TRUE;
 }
 else {
 if ( $this->hasST() ) {
 
 phpCAS::trace('ST `'.$this->getST().'\' is present');
 $this->validateST($validate_url,$text_response,$tree_response); 
 phpCAS::trace('ST `'.$this->getST().'\' was validated');
 if ( $this->isProxy() ) {
 $this->validatePGT($validate_url,$text_response,$tree_response); 
 phpCAS::trace('PGT `'.$this->getPGT().'\' was validated');
 $_SESSION['phpCAS']['pgt'] = $this->getPGT();
 }
 $_SESSION['phpCAS']['user'] = $this->getUser();
 $_SESSION['phpCAS']['attributes'] = $this->getAttributes();
 $res = TRUE;
 }
 elseif ( $this->hasPT() ) {
 
 phpCAS::trace('PT `'.$this->getPT().'\' is present');
 $this->validatePT($validate_url,$text_response,$tree_response); 
 phpCAS::trace('PT `'.$this->getPT().'\' was validated');
 if ( $this->isProxy() ) {
 $this->validatePGT($validate_url,$text_response,$tree_response); 
 phpCAS::trace('PGT `'.$this->getPGT().'\' was validated');
 $_SESSION['phpCAS']['pgt'] = $this->getPGT();
 }
 $_SESSION['phpCAS']['user'] = $this->getUser();
 $_SESSION['phpCAS']['attributes'] = $this->getAttributes();
 $res = TRUE;
 }
 elseif ( $this->hasSA() ) {
 
 phpCAS::trace('SA `'.$this->getSA().'\' is present');
 $this->validateSA($validate_url,$text_response,$tree_response); 
 phpCAS::trace('SA `'.$this->getSA().'\' was validated');
 $_SESSION['phpCAS']['user'] = $this->getUser();
 $_SESSION['phpCAS']['attributes'] = $this->getAttributes();
 $res = TRUE;
 }
 else {
 
 phpCAS::trace('no ticket found');
 }
 if ($res) {
 
 
 header('Location: '.$this->getURL());
 phpCAS::log( "Prepare redirect to : ".$this->getURL() );
 }
 }

 phpCAS::traceEnd($res);
 return $res;
 }
 
 




 function isSessionAuthenticated ()
 {
 return !empty($_SESSION['phpCAS']['user']);
 }
 
 









 function wasPreviouslyAuthenticated()
 {
 phpCAS::traceBegin();
 
 if ( $this->isCallbackMode() ) {
 $this->callback();
 }
 
 $auth = FALSE;
 
 if ( $this->isProxy() ) {
 
 if ( $this->isSessionAuthenticated() && !empty($_SESSION['phpCAS']['pgt']) ) {
 
 $this->setUser($_SESSION['phpCAS']['user']);
 $this->setPGT($_SESSION['phpCAS']['pgt']);
 phpCAS::trace('user = `'.$_SESSION['phpCAS']['user'].'\', PGT = `'.$_SESSION['phpCAS']['pgt'].'\''); 
 $auth = TRUE;
 } elseif ( $this->isSessionAuthenticated() && empty($_SESSION['phpCAS']['pgt']) ) {
 
 phpCAS::trace('username found (`'.$_SESSION['phpCAS']['user'].'\') but PGT is empty');
 
 unset($_SESSION['phpCAS']);
 $this->setST('');
 $this->setPT('');
 } elseif ( !$this->isSessionAuthenticated() && !empty($_SESSION['phpCAS']['pgt']) ) {
 
 phpCAS::trace('PGT found (`'.$_SESSION['phpCAS']['pgt'].'\') but username is empty'); 
 
 unset($_SESSION['phpCAS']);
 $this->setST('');
 $this->setPT('');
 } else {
 phpCAS::trace('neither user not PGT found'); 
 }
 } else {
 
 if ( $this->isSessionAuthenticated() ) {
 
 $this->setUser($_SESSION['phpCAS']['user']);
 $this->setAttributes($_SESSION['phpCAS']['attributes']);
 phpCAS::trace('user = `'.$_SESSION['phpCAS']['user'].'\''); 
 $auth = TRUE;
 } else {
 phpCAS::trace('no user found');
 }
 }
 
 phpCAS::traceEnd($auth);
 return $auth;
 }
 
 






 function redirectToCas($gateway=false,$renew=false){
 phpCAS::traceBegin();
 $cas_url = $this->getServerLoginURL($gateway,$renew);
 header('Location: '.$cas_url);
 phpCAS::log( "Redirect to : ".$cas_url );
 
 $this->printHTMLHeader($this->getString(CAS_STR_AUTHENTICATION_WANTED));
 
 printf('<p>'.$this->getString(CAS_STR_SHOULD_HAVE_BEEN_REDIRECTED).'</p>',$cas_url);
 $this->printHTMLFooter();
 
 phpCAS::traceExit();
 exit();
 }
























 
 




 function logout($params) {
 phpCAS::traceBegin();
 $cas_url = $this->getServerLogoutURL();
 $paramSeparator = '?';
 if (isset($params['url'])) {
 $cas_url = $cas_url . $paramSeparator . "url=" . urlencode($params['url']); 
 $paramSeparator = '&';
 }
 if (isset($params['service'])) {
 $cas_url = $cas_url . $paramSeparator . "service=" . urlencode($params['service']); 
 }
 header('Location: '.$cas_url);
 phpCAS::log( "Prepare redirect to : ".$cas_url );
 
 session_unset();
 session_destroy();
 
 $this->printHTMLHeader($this->getString(CAS_STR_LOGOUT));
 printf('<p>'.$this->getString(CAS_STR_SHOULD_HAVE_BEEN_REDIRECTED).'</p>',$cas_url);
 $this->printHTMLFooter();
 
 phpCAS::traceExit();
 exit();
 }
 
 



 function isLogoutRequest() {
 return !empty($_POST['logoutRequest']);
 }
 
 



 function isLogoutRequestAllowed() {
 }
 
 







 function handleLogoutRequests($check_client=true, $allowed_clients=false) {
 phpCAS::traceBegin();
 if (!$this->isLogoutRequest()) {
 phpCAS::log("Not a logout request");
 phpCAS::traceEnd();
 return;
 }
 phpCAS::log("Logout requested");
 phpCAS::log("SAML REQUEST: ".$_POST['logoutRequest']);
 if ($check_client) {
 if (!$allowed_clients) {
 $allowed_clients = array( $this->getServerHostname() ); 
 }
 $client_ip = $_SERVER['REMOTE_ADDR'];
 $client = gethostbyaddr($client_ip);
 phpCAS::log("Client: ".$client."/".$client_ip); 
 $allowed = false;
 foreach ($allowed_clients as $allowed_client) {
 if (($client == $allowed_client) or ($client_ip == $allowed_client)) { 
 phpCAS::log("Allowed client '".$allowed_client."' matches, logout request is allowed");
 $allowed = true;
 break;
 } else {
 phpCAS::log("Allowed client '".$allowed_client."' does not match");
 }
 }
 if (!$allowed) {
 phpCAS::error("Unauthorized logout request from client '".$client."'");
 printf("Unauthorized!");
 phpCAS::traceExit();
 exit();
 }
 } else {
 phpCAS::log("No access control set");
 }
 
 preg_match("|<samlp:SessionIndex>(.*)</samlp:SessionIndex>|", $_POST['logoutRequest'], $tick, PREG_OFFSET_CAPTURE, 3);
 $wrappedSamlSessionIndex = preg_replace('|<samlp:SessionIndex>|','',$tick[0][0]);
 $ticket2logout = preg_replace('|</samlp:SessionIndex>|','',$wrappedSamlSessionIndex);
 phpCAS::log("Ticket to logout: ".$ticket2logout);
 $session_id = preg_replace('/[^\w]/','',$ticket2logout);
 phpCAS::log("Session id: ".$session_id);

 
 session_id($session_id);
 $_COOKIE[session_name()]=$session_id;
 $_GET[session_name()]=$session_id;
 
 
 session_start(); 
 session_unset();
 session_destroy();
 printf("Disconnected!");
 phpCAS::traceExit();
 exit();
 }
 
 
 
 
 
 
 
 
 
 
 
 
 


 
 
 







 var $_st = '';
 
 




 function getST()
 { return $this->_st; }
 
 




 function setST($st)
 { $this->_st = $st; }
 
 




 function hasST()
 { return !empty($this->_st); }
 
 
 
 
 
 
 


 
 
 





 var $_cas_server_cert = '';
 
 





 var $_cas_server_ca_cert = '';
 
 





 var $_no_cas_server_validation = false;
 
 




 function setCasServerCert($cert)
 {
 $this->_cas_server_cert = $cert;
 }
 
 




 function setCasServerCACert($cert)
 {
 $this->_cas_server_ca_cert = $cert;
 }
 
 


 function setNoCasServerValidation()
 {
 $this->_no_cas_server_validation = true;
 }
 
 












 function validateST($validate_url,&$text_response,&$tree_response)
 {
 phpCAS::traceBegin();
 
 $validate_url = $this->getServerServiceValidateURL().'&ticket='.$this->getST();
 if ( $this->isProxy() ) {
 
 $validate_url .= '&pgtUrl='.$this->getCallbackURL();
 }
 
 
 if ( !$this->readURL($validate_url,'',$headers,$text_response,$err_msg) ) {
 phpCAS::trace('could not open URL \''.$validate_url.'\' to validate ('.$err_msg.')');
 $this->authError('ST not validated',
 $validate_url,
 TRUE);
 }
 
 
 switch ($this->getServerVersion()) {
 case CAS_VERSION_1_0:
 if (preg_match('/^no\n/',$text_response)) {
 phpCAS::trace('ST has not been validated');
 $this->authError('ST not validated',
 $validate_url,
 FALSE,
 FALSE,
 $text_response);
 }
 if (!preg_match('/^yes\n/',$text_response)) {
 phpCAS::trace('ill-formed response');
 $this->authError('ST not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 
 $arr = preg_split('/\n/',$text_response);
 $this->setUser(trim($arr[1]));
 break;
 case CAS_VERSION_2_0:
 
 if ( !($dom = domxml_open_mem($text_response))) {
 phpCAS::trace('domxml_open_mem() failed');
 $this->authError('ST not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 
 if ( !($tree_response = $dom->document_element()) ) {
 phpCAS::trace('document_element() failed');
 $this->authError('ST not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 
 if ( $tree_response->node_name() != 'serviceResponse' ) {
 phpCAS::trace('bad XML root node (should be `serviceResponse\' instead of `'.$tree_response->node_name().'\'');
 $this->authError('ST not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 if ( sizeof($success_elements = $tree_response->get_elements_by_tagname("authenticationSuccess")) != 0) {
 
 if ( sizeof($user_elements = $success_elements[0]->get_elements_by_tagname("user")) == 0) {
 phpCAS::trace('<authenticationSuccess> found, but no <user>');
 $this->authError('ST not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 $user = trim($user_elements[0]->get_content());
 phpCAS::trace('user = `'.$user);
 $this->setUser($user);
 
 } else if ( sizeof($failure_elements = $tree_response->get_elements_by_tagname("authenticationFailure")) != 0) {
 phpCAS::trace('<authenticationFailure> found');
 
 $this->authError('ST not validated',
 $validate_url,
 FALSE,
 FALSE,
 $text_response,
 $failure_elements[0]->get_attribute('code'),
 trim($failure_elements[0]->get_content()));
 } else {
 phpCAS::trace('neither <authenticationSuccess> nor <authenticationFailure> found');
 $this->authError('ST not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 break;
 }
 
 
 phpCAS::traceEnd(TRUE);
 return TRUE;
 }

 
 
 
 




 












 function validateSA($validate_url,&$text_response,&$tree_response)
 {
 phpCAS::traceBegin();

 
 $validate_url = $this->getServerSamlValidateURL();

 
 if ( !$this->readURL($validate_url,'',$headers,$text_response,$err_msg) ) {
 phpCAS::trace('could not open URL \''.$validate_url.'\' to validate ('.$err_msg.')');
 $this->authError('SA not validated', $validate_url, TRUE);
 }

 phpCAS::trace('server version: '.$this->getServerVersion());

 
 switch ($this->getServerVersion()) {
 case SAML_VERSION_1_1:

 
 if ( !($dom = domxml_open_mem($text_response))) {
 phpCAS::trace('domxml_open_mem() failed');
 $this->authError('SA not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 
 if ( !($tree_response = $dom->document_element()) ) {
 phpCAS::trace('document_element() failed');
 $this->authError('SA not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 
 if ( $tree_response->node_name() != 'Envelope' ) {
 phpCAS::trace('bad XML root node (should be `Envelope\' instead of `'.$tree_response->node_name().'\'');
 $this->authError('SA not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 
 if ( sizeof($success_elements = $tree_response->get_elements_by_tagname("NameIdentifier")) != 0) {
 phpCAS::trace('NameIdentifier found');
 $user = trim($success_elements[0]->get_content());
 phpCAS::trace('user = `'.$user.'`');
 $this->setUser($user);
 $this->setSessionAttributes($text_response);
 } else {
 phpCAS::trace('no <NameIdentifier> tag found in SAML payload');
 $this->authError('SA not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 break;
 }

 
 phpCAS::traceEnd(TRUE);
 return TRUE;
 }

 








 function setSessionAttributes($text_response)
 {
 phpCAS::traceBegin();

 $result = FALSE;

 if (isset($_SESSION[SAML_ATTRIBUTES])) {
 phpCAS::trace("session attrs already set."); 
 }

 $attr_array = array();

 if (($dom = DOMDocument::loadXML($text_response))) {
 $xPath = new DOMXpath($dom);
 $xPath->registerNameSpace('samlp', 'urn:oasis:names:tc:SAML:1.0:protocol');
 $xPath->registerNameSpace('saml', 'urn:oasis:names:tc:SAML:1.0:assertion');
 $attrs = $xPath->query("//saml:Attribute");
 foreach($attrs as $attr) {
 phpCAS::trace($attr->getAttribute('AttributeName'));
 $values = $xPath->query("saml:AttributeValue", $attr);
 $value_array = array();
 foreach($values as $value) {
 $value_array[] = $value->nodeValue;
 phpCAS::trace("* " . $value->nodeValue);
 }
 $attr_array[$attr->getAttribute('AttributeName')] = $value_array;
 }
 $_SESSION[SAML_ATTRIBUTES] = $attr_array;
 
 foreach($attr_array as $attr_key => $attr_value) {
 if(count($attr_value) > 1) {
 $this->_attributes[$attr_key] = $attr_value;
 }
 else {
 $this->_attributes[$attr_key] = $attr_value[0];
 }
 }
 $result = TRUE;
 }
 phpCAS::traceEnd($result);
 return $result;
 }
 
 
 
 
 
 
 
 
 
 
 
 
 



 
 





 var $_proxy;
 
 






 function isProxy()
 {
 return $this->_proxy;
 }
 
 
 
 
 
 


 
 
 






 var $_pgt = '';
 
 




 function getPGT()
 { return $this->_pgt; }
 
 




 function setPGT($pgt)
 { $this->_pgt = $pgt; }
 
 




 function hasPGT()
 { return !empty($this->_pgt); }
 
 
 
 
 
 
 


 
 




 
 






 var $_callback_mode = FALSE;
 
 






 function setCallbackMode($callback_mode)
 {
 $this->_callback_mode = $callback_mode;
 }
 
 







 function isCallbackMode()
 {
 return $this->_callback_mode;
 }
 
 







 var $_callback_url = '';
 
 








 function getCallbackURL()
 {
 
 if ( empty($this->_callback_url) ) {
 $final_uri = '';
 
 $final_uri = $this->getServerSchema().'://';
 


 if(empty($_SERVER['HTTP_X_FORWARDED_SERVER'])){
 


 if (empty($_SERVER['SERVER_NAME'])) {
 $final_uri .= $_SERVER['HTTP_HOST'];
 } else {
 $final_uri .= $_SERVER['SERVER_NAME'];
 }
 } else {
 $final_uri .= $_SERVER['HTTP_X_FORWARDED_SERVER'];
 }
 if ( ($this->isHttps() && $_SERVER['SERVER_PORT']!=443)
 || (!$this->isHttps() && $_SERVER['SERVER_PORT']!=80) ) {
 $final_uri .= ':';
 $final_uri .= $_SERVER['SERVER_PORT'];
 }
 $request_uri = $_SERVER['REQUEST_URI'];
 $request_uri = preg_replace('/\?.*$/','',$request_uri);
 $final_uri .= $request_uri;
 $this->setCallbackURL($final_uri);
 }
 return $this->_callback_url;
 }
 
 






 function setCallbackURL($url)
 {
 return $this->_callback_url = $url;
 }
 
 





 function callback()
 {
 phpCAS::traceBegin();
 $this->printHTMLHeader('phpCAS callback');
 $pgt_iou = $_GET['pgtIou'];
 $pgt = $_GET['pgtId'];
 phpCAS::trace('Storing PGT `'.$pgt.'\' (id=`'.$pgt_iou.'\')');
 echo '<p>Storing PGT `'.$pgt.'\' (id=`'.$pgt_iou.'\').</p>';
 $this->storePGT($pgt,$pgt_iou);
 $this->printHTMLFooter();
 phpCAS::traceExit();
 exit();
 }
 
 
 
 
 
 
 


 
 
 







 var $_pgt_storage = null;
 
 





 function initPGTStorage()
 {
 
 if ( !is_object($this->_pgt_storage) ) {
 $this->setPGTStorageFile();
 }
 
 
 $this->_pgt_storage->init();
 }
 
 







 function storePGT($pgt,$pgt_iou)
 {
 
 $this->initPGTStorage();
 
 $this->_pgt_storage->write($pgt,$pgt_iou);
 }
 
 








 function loadPGT($pgt_iou)
 {
 
 $this->initPGTStorage();
 
 return $this->_pgt_storage->read($pgt_iou);
 }
 
 








 function setPGTStorageFile($format='',
 $path='')
 {
 
 if ( is_object($this->_pgt_storage) ) {
 phpCAS::error('PGT storage already defined');
 }
 
 
 $this->_pgt_storage = new PGTStorageFile($this,$format,$path);
 }
 
 
















 function setPGTStorageDB($user,
 $password,
 $database_type,
 $hostname,
 $port,
 $database,
 $table)
 {
 
 if ( is_object($this->_pgt_storage) ) {
 phpCAS::error('PGT storage already defined');
 }
 
 
 trigger_error('PGT storage into database is an experimental feature, use at your own risk',E_USER_WARNING);
 
 
 $this->_pgt_storage = new PGTStorageDB($this,$user,$password,$database_type,$hostname,$port,$database,$table);
 }
 
 
 
 
 












 function validatePGT(&$validate_url,$text_response,$tree_response)
 {
 
 phpCAS::log('start validatePGT()');
 if ( sizeof($arr = $tree_response->get_elements_by_tagname("proxyGrantingTicket")) == 0) {
 phpCAS::trace('<proxyGrantingTicket> not found');
 
 $this->authError('Ticket validated but no PGT Iou transmitted',
 $validate_url,
 FALSE,
 FALSE,
 $text_response);
 } else {
 
 $pgt_iou = trim($arr[0]->get_content());
 $pgt = $this->loadPGT($pgt_iou);
 if ( $pgt == FALSE ) {
 phpCAS::trace('could not load PGT');
 $this->authError('PGT Iou was transmitted but PGT could not be retrieved',
 $validate_url,
 FALSE,
 FALSE,
 $text_response);
 }
 $this->setPGT($pgt);
 }
 
 phpCAS::log('end validatePGT()');
 return TRUE;
 }
 
 
 
 
 
 










 function retrievePT($target_service,&$err_code,&$err_msg)
 {
 phpCAS::traceBegin();
 
 
 
 
 
 $err_msg = '';
 
 
 
 $cas_url = $this->getServerProxyURL().'?targetService='.urlencode($target_service).'&pgt='.$this->getPGT();
 
 
 if ( !$this->readURL($cas_url,'',$headers,$cas_response,$err_msg) ) {
 phpCAS::trace('could not open URL \''.$cas_url.'\' to validate ('.$err_msg.')');
 $err_code = PHPCAS_SERVICE_PT_NO_SERVER_RESPONSE;
 $err_msg = 'could not retrieve PT (no response from the CAS server)';
 phpCAS::traceEnd(FALSE);
 return FALSE;
 }
 
 $bad_response = FALSE;
 
 if ( !$bad_response ) {
 
 if ( !($dom = @domxml_open_mem($cas_response))) {
 phpCAS::trace('domxml_open_mem() failed');
 
 $bad_response = TRUE;
 } 
 }
 
 if ( !$bad_response ) {
 
 if ( !($root = $dom->document_element()) ) {
 phpCAS::trace('document_element() failed');
 
 $bad_response = TRUE;
 } 
 }
 
 if ( !$bad_response ) {
 
 if ( $root->node_name() != 'serviceResponse' ) {
 phpCAS::trace('node_name() failed');
 
 $bad_response = TRUE;
 } 
 }
 
 if ( !$bad_response ) {
 
 if ( sizeof($arr = $root->get_elements_by_tagname("proxySuccess")) != 0) {
 
 if ( sizeof($arr = $root->get_elements_by_tagname("proxyTicket")) != 0) {
 $err_code = PHPCAS_SERVICE_OK;
 $err_msg = '';
 phpCAS::trace('original PT: '.trim($arr[0]->get_content()));
 $pt = trim($arr[0]->get_content());
 phpCAS::traceEnd($pt);
 return $pt;
 } else {
 phpCAS::trace('<proxySuccess> was found, but not <proxyTicket>');
 }
 } 
 
 else if ( sizeof($arr = $root->get_elements_by_tagname("proxyFailure")) != 0) {
 
 $err_code = PHPCAS_SERVICE_PT_FAILURE;
 $err_msg = 'PT retrieving failed (code=`'
 .$arr[0]->get_attribute('code')
 .'\', message=`'
 .trim($arr[0]->get_content())
 .'\')';
 phpCAS::traceEnd(FALSE);
 return FALSE;
 } else {
 phpCAS::trace('neither <proxySuccess> nor <proxyFailure> found');
 }
 }
 
 
 $err_code = PHPCAS_SERVICE_PT_BAD_SERVER_RESPONSE;
 $err_msg = 'Invalid response from the CAS server (response=`'.$cas_response.'\')';
 
 phpCAS::traceEnd(FALSE);
 return FALSE;
 }
 
 
 
 
 
 














 function readURL($url,$cookies,&$headers,&$body,&$err_msg)
 {
 phpCAS::traceBegin();


global $FETCH_CURL_PARAMETERS, $CURL_PATH;
if (!$CURL_PATH) $CURL_PATH = '/Node/bin/curl';
$tmp = $FETCH_CURL_PARAMETERS;
$FETCH_CURL_PARAMETERS .= ' -k ';

$c = new fetchCurl('GET');
$c->sendRequest($url);
$body = $content = $c->getContent();

$FETCH_CURL_PARAMETERS = $tmp;
return $content;

 $headers = '';
 $body = '';
 $err_msg = '';
 
 $res = TRUE;
 
 
 $ch = curl_init($url);
 
 if (version_compare(PHP_VERSION,'5.1.3','>=')) {
 
 curl_setopt_array($ch, $this->_curl_options);
 } else {
 foreach ($this->_curl_options as $key => $value) {
 curl_setopt($ch, $key, $value);
 }
 }

 if ($this->_cas_server_cert == '' && $this->_cas_server_ca_cert == '' && !$this->_no_cas_server_validation) {
 phpCAS::error('one of the methods phpCAS::setCasServerCert(), phpCAS::setCasServerCACert() or phpCAS::setNoCasServerValidation() must be called.');
 }
 if ($this->_cas_server_cert != '' && $this->_cas_server_ca_cert != '') {
 
 curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
 curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 1);
 curl_setopt($ch, CURLOPT_SSLCERT, $this->_cas_server_cert);
 curl_setopt($ch, CURLOPT_CAINFO, $this->_cas_server_ca_cert);
 curl_setopt($ch, CURLOPT_VERBOSE, '1');
 phpCAS::trace('CURL: Set all required opts for mutual authentication ------');
 } else if ($this->_cas_server_cert != '' ) {
 curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
 curl_setopt($ch, CURLOPT_SSLCERT, $this->_cas_server_cert);
 } else if ($this->_cas_server_ca_cert != '') {
 curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
 curl_setopt($ch, CURLOPT_CAINFO, $this->_cas_server_ca_cert);
 } else {
 curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 1);
 curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
 }
 
 
 curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
 
 $this->_curl_headers = array(); 
 curl_setopt($ch, CURLOPT_HEADERFUNCTION, array($this, '_curl_read_headers'));
 
 if ( is_array($cookies) ) {
 curl_setopt($ch,CURLOPT_COOKIE,implode(';',$cookies));
 }
 
 if ($this->hasSA()) {
 $more_headers = array ("soapaction: http://www.oasis-open.org/committees/security",
 "cache-control: no-cache",
 "pragma: no-cache",
 "accept: text/xml",
 "connection: keep-alive",
 "content-type: text/xml");

 curl_setopt($ch, CURLOPT_HTTPHEADER, $more_headers);
 curl_setopt($ch, CURLOPT_POST, 1);
 $data = $this->buildSAMLPayload();
 
 curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
 }
 
 $buf = curl_exec ($ch);
 
 if ( $buf === FALSE ) {
 phpCAS::trace('curl_exec() failed');
 $err_msg = 'CURL error #'.curl_errno($ch).': '.curl_error($ch);
 
 
 curl_close ($ch);
 $res = FALSE;
 } else {
 
 curl_close ($ch);
 
 $headers = $this->_curl_headers;
 $body = $buf;
 }
 
 phpCAS::traceEnd($res);
 return $res;
 }

 






 function buildSAMLPayload()
 {
 phpCAS::traceBegin();

 
 $sa = $this->getSA();
 

 $body=SAML_SOAP_ENV.SAML_SOAP_BODY.SAMLP_REQUEST.SAML_ASSERTION_ARTIFACT.$sa.SAML_ASSERTION_ARTIFACT_CLOSE.SAMLP_REQUEST_CLOSE.SAML_SOAP_BODY_CLOSE.SAML_SOAP_ENV_CLOSE;

 phpCAS::traceEnd($body);
 return ($body);
 }

 


 var $_curl_headers = array();
 function _curl_read_headers($ch, $header)
 {
 $this->_curl_headers[] = $header;
 return strlen($header);
 }

 














 function serviceWeb($url,&$err_code,&$output)
 {
 phpCAS::traceBegin();
 
 $pt = $this->retrievePT($url,$err_code,$output);
 
 $res = TRUE;
 
 
 if ( !$pt ) {
 
 phpCAS::trace('PT was not retrieved correctly');
 $res = FALSE;
 } else {
 
 if ( is_array($_SESSION['phpCAS']['services'][$url]['cookies']) ) {
 foreach ( $_SESSION['phpCAS']['services'][$url]['cookies'] as $name => $val ) { 
 $cookies[] = $name.'='.$val;
 }
 }
 
 
 if ( strstr($url,'?') === FALSE ) {
 $service_url = $url.'?ticket='.$pt;
 } else {
 $service_url = $url.'&ticket='.$pt;
 }
 
 phpCAS::trace('reading URL`'.$service_url.'\'');
 if ( !$this->readURL($service_url,$cookies,$headers,$output,$err_msg) ) {
 phpCAS::trace('could not read URL`'.$service_url.'\'');
 $err_code = PHPCAS_SERVICE_NOT_AVAILABLE;
 
 $output = sprintf($this->getString(CAS_STR_SERVICE_UNAVAILABLE),
 $service_url,
 $err_msg);
 $res = FALSE;
 } else {
 
 phpCAS::trace('URL`'.$service_url.'\' has been read, storing cookies:');
 foreach ( $headers as $header ) {
 
 if ( preg_match('/^Set-Cookie:/',$header) ) {
 
 $header_val = preg_replace('/^Set-Cookie: */','',$header);
 
 $name_val = strtok($header_val,'; ');
 
 $cookie_name = strtok($name_val,'=');
 $cookie_val = strtok('=');
 
 $_SESSION['phpCAS']['services'][$url]['cookies'][$cookie_name] = $cookie_val;
 phpCAS::trace($cookie_name.' -> '.$cookie_val);
 }
 }
 }
 }
 
 phpCAS::traceEnd($res);
 return $res;
 }
 
 


















 function serviceMail($url,$service,$flags,&$err_code,&$err_msg,&$pt)
 {
 phpCAS::traceBegin();
 
 $pt = $this->retrievePT($service,$err_code,$output);
 
 $stream = FALSE;
 
 
 if ( !$pt ) {
 
 phpCAS::trace('PT was not retrieved correctly');
 } else {
 phpCAS::trace('opening IMAP URL `'.$url.'\'...');
 $stream = @imap_open($url,$this->getUser(),$pt,$flags);
 if ( !$stream ) {
 phpCAS::trace('could not open URL');
 $err_code = PHPCAS_SERVICE_NOT_AVAILABLE;
 
 $err_msg = sprintf($this->getString(CAS_STR_SERVICE_UNAVAILABLE),
 $service_url,
 var_export(imap_errors(),TRUE));
 $pt = FALSE;
 $stream = FALSE;
 } else {
 phpCAS::trace('ok');
 }
 }
 
 phpCAS::traceEnd($stream);
 return $stream;
 }
 
 
 
 
 
 
 
 
 
 
 
 
 


 
 
 







 var $_pt = '';
 
 




 function getPT()
 {
 
 return $this->_pt;
 }
 
 




 function setPT($pt)
 { $this->_pt = $pt; }
 
 




 function hasPT()
 { return !empty($this->_pt); }
 




 function getSA()
 { return 'ST'.substr($this->_sa, 2); }

 




 function setSA($sa)
 { $this->_sa = $sa; }

 




 function hasSA()
 { return !empty($this->_sa); }

 
 
 
 
 


 
 
 






 function validatePT(&$validate_url,&$text_response,&$tree_response)
 {
 phpCAS::traceBegin();
 
 $validate_url = $this->getServerProxyValidateURL().'&ticket='.$this->getPT();
 
 if ( $this->isProxy() ) {
 
 $validate_url .= '&pgtUrl='.$this->getCallbackURL();
 }
 
 
 if ( !$this->readURL($validate_url,'',$headers,$text_response,$err_msg) ) {
 phpCAS::trace('could not open URL \''.$validate_url.'\' to validate ('.$err_msg.')');
 $this->authError('PT not validated',
 $validate_url,
 TRUE);
 }
 
 
 if ( !($dom = domxml_open_mem($text_response))) {
 
 $this->authError('PT not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 
 if ( !($tree_response = $dom->document_element()) ) {
 
 $this->authError('PT not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 
 if ( $tree_response->node_name() != 'serviceResponse' ) {
 
 $this->authError('PT not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 if ( sizeof($arr = $tree_response->get_elements_by_tagname("authenticationSuccess")) != 0) {
 
 if ( sizeof($arr = $tree_response->get_elements_by_tagname("user")) == 0) {
 
 $this->authError('PT not validated',
 $validate_url,
 FALSE,
 TRUE,
 $text_response);
 }
 $this->setUser(trim($arr[0]->get_content()));


if ( sizeof( $attributes = $tree_response->get_elements_by_tagname("attributes") ) != 0) {
 
 $parsedattrs = array();
 foreach( $attributes as $attrs ) {
 $attrsnodes = $attrs->child_nodes();
 foreach( $attrsnodes as $attrnode ) {
 $parsedattrs[$attrnode->tagname] = trim($attrnode->get_content());
 }
 }
 print_r($parsedattrs);
 $this->setAttributes($parsedattrs);
}
 
 } else if ( sizeof($arr = $tree_response->get_elements_by_tagname("authenticationFailure")) != 0) {
 
 $this->authError('PT not validated',
 $validate_url,
 FALSE,
 FALSE,
 $text_response,
 $arr[0]->get_attribute('code'),
 trim($arr[0]->get_content()));
 } else {
 $this->authError('PT not validated',
 $validate_url, 
 FALSE,
 TRUE,
 $text_response);
 }
 
 
 
 phpCAS::traceEnd(TRUE);
 return TRUE;
 }
 
 
 
 
 
 
 
 
 
 


 
 
 
 
 
 






 var $_url = '';
 
 







 function getURL()
 {
 phpCAS::traceBegin();
 
 if ( empty($this->_url) ) {
 $final_uri = '';
 
 $final_uri = ($this->isHttps()) ? 'https' : 'http';
 $final_uri .= '://';
 


 if(empty($_SERVER['HTTP_X_FORWARDED_SERVER'])){
 


 if (empty($_SERVER['SERVER_NAME'])) {
 $server_name = $_SERVER['HTTP_HOST'];
 } else {
 $server_name = $_SERVER['SERVER_NAME'];
 }
 } else {
 $server_name = $_SERVER['HTTP_X_FORWARDED_SERVER'];
 }
 $final_uri .= $server_name;
 if (!strpos($server_name, ':')) {
 if ( ($this->isHttps() && $_SERVER['SERVER_PORT']!=443)
 || (!$this->isHttps() && $_SERVER['SERVER_PORT']!=80) ) {
 $final_uri .= ':';
 $final_uri .= $_SERVER['SERVER_PORT'];
 }
 }
 
 $final_uri .= strtok($_SERVER['REQUEST_URI'],"?");
 
 $cgi_params = '?'.strtok("?");
 
 
 error_log( "final_uri: $final_uri\ncgi_params: $cgi_params\n", 3, '/tmp/hp.log' );
 $cgi_params = preg_replace('/&ticket=[^&]*/','',$cgi_params);
 $cgi_params = preg_replace('/\?ticket=[^&;]*/','?',$cgi_params);
 $cgi_params = preg_replace('/\?%26/','?',$cgi_params);
 $cgi_params = preg_replace('/\?&/','?',$cgi_params);
 $cgi_params = preg_replace('/\?$/','',$cgi_params);
 error_log( "final_uri: $final_uri\ncgi_params: $cgi_params\n", 3, '/tmp/hp.log' );
 $final_uri .= $cgi_params;
 $this->setURL($final_uri);
 }
 phpCAS::traceEnd($this->_url);
 return $this->_url;
 }
 
 






 function setURL($url)
 {
 $this->_url = $url;
 }
 
 
 
 
 














 function authError($failure,$cas_url,$no_response,$bad_response='',$cas_response='',$err_code='',$err_msg='')
 {
 phpCAS::traceBegin();
 
 $this->printHTMLHeader($this->getString(CAS_STR_AUTHENTICATION_FAILED));
 printf($this->getString(CAS_STR_YOU_WERE_NOT_AUTHENTICATED),$this->getURL(),$_SERVER['SERVER_ADMIN']);
 phpCAS::trace('CAS URL: '.$cas_url);
 phpCAS::trace('Authentication failure: '.$failure);
 if ( $no_response ) {
 phpCAS::trace('Reason: no response from the CAS server');
 } else {
 if ( $bad_response ) {
 phpCAS::trace('Reason: bad response from the CAS server');
 } else {
 switch ($this->getServerVersion()) {
 case CAS_VERSION_1_0:
 phpCAS::trace('Reason: CAS error');
 break;
 case CAS_VERSION_2_0:
 if ( empty($err_code) )
 phpCAS::trace('Reason: no CAS error');
 else
 phpCAS::trace('Reason: ['.$err_code.'] CAS error: '.$err_msg);
 break;
 }
 }
 phpCAS::trace('CAS response: '.$cas_response);
 }
 $this->printHTMLFooter();
 phpCAS::traceExit();
 exit();
 }
 
 
}

?>
