<?

class CNFolderPublishers extends BaseObject {

 var $folder_id;
 var $list;
 
 function CNFolderPublishers($folder_id) {
 $this->folder_id = $folder_id;
 $this->list = false;
 }
 
 function save($folder_id = 0) {
 if (!$folder_id) $folder_id = $this->folder_id;
 
 if ($folder_id == $this->folder_id && $this->list === false) {
 return;
 }
 
 $sql = "SELECT id, objid, objtype, sort FROM folder_publisher WHERE folder_id = ".sqlf_tl_num($folder_id);
 $rs = query($sql);
 }
 
 function isEmpty() {
 if ($this->list === false) $this->_loadList();
 return (count($this->list) == 0);
 }

 


 function setPublishers($list) {
 $this->list = $list;
 }
 
 




 function getPublishers($resolveName = false, $parentGroups = 0) {
 global $ICO_USER, $ICO_GROUP, $T_GROUP;
 
 if ($this->list === false) $this->_loadList();
 $list = array();
 foreach ($this->list as $row) {
 $row["icon"] = $row["objtype"] == $T_GROUP ? $ICO_GROUP : $ICO_USER;
 if (!$row["name"] && $resolveName) {
 if ($row["objtype"]== $T_GROUP) {
 $sql = "SELECT mother, name FROM usergroup WHERE id = ".sqlf_tl_num($row["objid"]);
 $rs = query($sql);
 $name = $rs["arr"][0]["name"];
 $mother = $rs["arr"][0]["mother"];
 if ($parentGroups > 0) {

 }
 $row["name"] = $name;
 } else {
 $sql = "SELECT firstname, lastname FROM systemuser WHERE id = ".sqlf_tl_num($row["objid"]);
 $rs = query($sql);
 $row["name"] = $rs["arr"][0]["lastname"]." ".$rs["arr"][0]["firstname"];
 }
 }
 }
 return $list;
 }

 function _loadList() {
 $sql = "SELECT id, objid, objtype, sort FROM folder_publisher WHERE folder_id = ".((int)$this->folder_id)." ORDER BY sort";
 $rs = query($sql);
 $this->list = $rs["arr"];
 }

 function _addRow($folder_id, $row) {
 $sql = "INSERT INTO folder_publisher (folder_id, objid, objtype, sort) VALUES 
		  (".sqlf_tl_num($folder_id).", ".sqlf_tl_num($row["objid"]).", ".sqlf_tl_num($row["objtype"]).", ".sqlf_tl_num($row["sort"]).")";
 $rs = query($sql);
 return $rs["iid"];
 }

 function _deleteRow($row) {
 
 
 $sql = "DELETE FROM folder_publisher WHERE id = ".sqlf_tl_num($row["id"]);
 query($sql);
 }

 function _updateRow($oldRow, $newRow) {

 $change = "";
 if ($oldRow["objtype"] != $newRow["objtype"] || $oldRow["objid"] != $newRow["objid"]) {
 
 
 if ($change) $change .= ", ";
 $change .= "objtype = \"".sqlf_escaped($newRow["objtype"])."\", objid = \"".sqlf_escaped($newRow["objid"])."\"";
 }
 if ($oldRow["sort"] != $newRow["sort"]) {
 
 
 if ($change) $change .= ", ";
 $change .= "sort = \"".sqlf_escaped($newRow["sort"])."\"";
 }
 
 $sql = "UPDATE folder_publisher SET $change WHERE id = ".sqlf_tl_num($newRow["id"]);
 query($sql);
 }
}

?>
